'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _readSourceFile = require('./read-source-file');

var _readSourceFile2 = _interopRequireDefault(_readSourceFile);

var _webpack = require('react-loadable/webpack');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(settings, modules) {
        var loadableBundleStatsPath, craBundleStatsPath, loadableBundleStats, craBundleStats, allBundles;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!(settings.disableJs === 'yes')) {
                            _context.next = 2;
                            break;
                        }

                        return _context.abrupt('return', {
                            js: [],
                            css: []
                        });

                    case 2:
                        loadableBundleStatsPath = _path2.default.join(settings.build, 'react-loadable.json');
                        craBundleStatsPath = _path2.default.join(settings.build, 'asset-manifest.json');
                        loadableBundleStats = false;
                        craBundleStats = false;
                        _context.prev = 6;
                        _context.next = 9;
                        return (0, _readSourceFile2.default)(loadableBundleStatsPath, true);

                    case 9:
                        loadableBundleStats = _context.sent;
                        _context.next = 14;
                        break;

                    case 12:
                        _context.prev = 12;
                        _context.t0 = _context['catch'](6);

                    case 14:
                        _context.prev = 14;
                        _context.next = 17;
                        return (0, _readSourceFile2.default)(craBundleStatsPath, true);

                    case 17:
                        craBundleStats = _context.sent;
                        _context.next = 22;
                        break;

                    case 20:
                        _context.prev = 20;
                        _context.t1 = _context['catch'](14);

                    case 22:
                        allBundles = false;

                        // generate assets map with the ReactLoadable bundles stats

                        if (loadableBundleStats !== false) {
                            try {
                                allBundles = (0, _webpack.getBundles)(loadableBundleStats, modules);
                            } catch (err) {
                                console.log('[ssr] "react-loadable.json" bundles stats failed - ' + err.message);
                            }
                        }

                        // use basic CRA's "asset-manifest.json"
                        if (allBundles === false && craBundleStats !== false) {
                            try {
                                allBundles = Object.keys(craBundleStats).filter(function (bundleName) {
                                    return modules.map(function (moduleName) {
                                        return moduleName.replace('./', '');
                                    }).some(function (moduleName) {
                                        return bundleName.indexOf(moduleName + '.js') !== -1 || bundleName.indexOf(moduleName + '.css') !== -1;
                                    });
                                }).map(function (bundleName) {
                                    return {
                                        bundleName: bundleName,
                                        file: craBundleStats[bundleName],
                                        publicPath: craBundleStats[bundleName]
                                    };
                                });
                            } catch (err) {
                                console.log('[ssr] "asset-manifest.json" bundles stats failed - ' + err.message);
                            }
                        }

                        // map bundles to assets files

                        if (!(allBundles !== false)) {
                            _context.next = 27;
                            break;
                        }

                        return _context.abrupt('return', {
                            js: allBundles.filter(function (bundle) {
                                return bundle.file.indexOf('.js') !== -1;
                            }) // target js
                            .filter(function (bundle) {
                                return bundle.file.indexOf('.map') === -1;
                            }) // remove maps
                            .map(function (bundle) {
                                return '<script type="text/javascript" src="' + bundle.publicPath + '"></script>';
                            }),
                            css: allBundles.filter(function (bundle) {
                                return bundle.file.indexOf('.css') !== -1;
                            }) // target css
                            .filter(function (bundle) {
                                return bundle.file.indexOf('.map') === -1;
                            }) // remove maps
                            .map(function (bundle) {
                                return '<link href="' + bundle.publicPath + '" rel="stylesheet">';
                            })
                        });

                    case 27:

                        console.log('[ssr] warning - it was not possible to produce the assets bundles mapping!');

                        return _context.abrupt('return', {
                            js: [],
                            css: []
                        });

                    case 29:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, undefined, [[6, 12], [14, 20]]);
    }));

    return function (_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();