'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var prepHTML = function prepHTML(template, _ref) {
    var html = _ref.html,
        head = _ref.head,
        body = _ref.body,
        state = _ref.state,
        jsBundles = _ref.jsBundles,
        cssBundles = _ref.cssBundles,
        disableJs = _ref.disableJs;

    var data = template;
    data = data.replace('<html lang="en">', '<html ' + html + '>');
    data = data.replace('</head>', '' + head + cssBundles.join('') + '</head>');

    // avoid to send out the redux state if client js is disabled
    if (disableJs !== 'yes') {
        // eslint-disable-next-line
        data = data.replace('<div id="root"></div>', '<div id="root"></div><script>window.REDUX_INITIAL_STATE = ' + JSON.stringify(state) + ';</script>');
    }

    // react-loadable -- inject chunks
    if (disableJs !== 'yes') {
        data = data.replace('<script src="/static/js/main.', jsBundles.join('') + '<script type="text/javascript" src="/static/js/main.');
    }

    // inject the pre-rendered body of the application
    data = data.replace('<div id="root"></div>', '<div id="root">' + body + '</div>');

    // remove bundle js (dev, experimental)
    if (disableJs === 'yes') {
        data = data.replace(/<script src="\/static\/js\/([^\s]*).js"><\/script>/g, '');
        data = data.replace(/<script.*>.*<\/script>/g, '');
    }

    return data;
};

exports.default = prepHTML;