'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var readSourceFile = function readSourceFile(filePath) {
    var parseJson = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var encoding = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'utf8';
    return new Promise(function (resolve, reject) {
        if (readSourceFile.cache[filePath]) {
            return resolve(readSourceFile.cache[filePath]);
        }

        try {
            _fs2.default.readFile(filePath, encoding, function (err, data) {
                if (err) {
                    reject(err);
                    return;
                }

                // optional json parse applied to the file
                var content = data;
                if (parseJson) {
                    try {
                        content = JSON.parse(data);
                    } catch (err) {
                        reject(err);
                        return;
                    }
                }

                readSourceFile.cache[filePath] = content;
                resolve(content);
            });
        } catch (err) {
            reject(err);
        }
    });
};

// setup file cache memoization
readSourceFile.cache = {};

exports.default = readSourceFile;